/*
 * Copyright 2010 JBoss Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 * 
 *       http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *  under the License.
 */

package org.kie.camel.component;

import org.apache.camel.CamelContext;
import org.apache.camel.Endpoint;
import org.apache.camel.impl.DefaultComponent;

import java.util.Map;

public class KieComponent extends DefaultComponent {
    // Property name *must* follow the Camel conventions (see org.apache.camel.Exchange)
    public static final String KIE_LOOKUP = "KieLookup";

    public KieComponent() {
    }

    public KieComponent(CamelContext context) {
        super( context );
    }

    @Override
    protected Endpoint createEndpoint(String uri,
                                      String remaining,
                                      Map<String, Object> parameters) throws Exception {
        Endpoint endpoint;
        endpoint = new KieEndpoint( uri,
                                       remaining,
                                       this );
        setProperties( endpoint,
                       parameters );
        return endpoint;
    }

    @Override
    protected void validateParameters(String uri,
                                      Map<String, Object> parameters,
                                      String optionPrefix) {

    }
}
